unit SpriteMgr;
interface
uses Graphics, Core;

var Sprites:array[0..MaxPlayers,0..10]of TBitmap;
    CursorSprites:array[1..MaxPlayers]of TBitmap;
    N4Logo:TBitmap;

procedure InitSprites;
procedure FreeSprites;

implementation

{$R Sprites.res}

function LoadResourceBitmap(const Name:string):TBitmap;
begin
  Result:=TBitmap.Create;
  Result.LoadFromResourceName(HInstance,Name);
end;

procedure InitSprites;
var BMP:TBitmap;
    P,F:integer;
begin
  BMP:=LoadResourceBitmap('Sprites');
  // Sprites
  for P:=0 to MaxPlayers do
    for F:=0 to 10 do begin
      Sprites[P,F]:=TBitmap.Create;
      with Sprites[P,F] do begin
        PixelFormat:=pfDevice;
        Width:=PixelsPerItem;
        Height:=PixelsPerItem;
        Canvas.Draw(-F*PixelsPerItem,-P*PixelsPerItem,BMP);
      end;
    end;
  // CursorSprites
  for P:=1 to MaxPlayers do begin
    CursorSprites[P]:=TBitmap.Create;
    with CursorSprites[P] do begin
      PixelFormat:=pfDevice;
      Width:=PixelsPerItem;
      Height:=PixelsPerItem+1;
      Canvas.Draw((1-P)*PixelsPerItem,(-MaxPlayers-1)*PixelsPerItem,BMP);
      TransparentMode:=tmAuto;
      Transparent:=true;
    end;
  end;
  BMP.Free;
  // N4Logo
  N4Logo:=LoadResourceBitmap('N4Logo');
end;

procedure FreeSprites;
var P,F:integer;
begin
  N4Logo.Free;
  for P:=0 to MaxPlayers do
    for F:=0 to 10 do
      Sprites[P,F].Free;
  for P:=1 to MaxPlayers do
    CursorSprites[P].Free;
end;

end.
